HDU-2955 Robberies 变形01背包

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05
Sample Output
2
4
6

题目大意:每件事有一个概率,在有限的概率内做哪些事能使获得的总价值最多。
思路:变形的01背包,把原本的累加变成累乘就好(独立事件的概率用乘法定律)。另外由于数组下标只能使整数,我们做如下处理:

	dp[i][j] = p; //表示做第i件事的时候,获得总价值为j的情况下,被抓的概率是p。

这样处理后,转移方程就变成了:

	dp[i][j] = max(dp[i - 1][j], dp[i - 1][j - w[i]] * (1 - p[i]));

可以发现和01背包的转移基本是一样的,我们做空间优化:

	dp[j] = max(dp[j], dp[j - w[i]] * (1 - p[i]));

AC代码

#include <iostream>
#include <cstring>
using namespace std;

double dp[10005],p[105];
int w[105];

int main() {
    int T;
    cin >> T;
    while (T--) {
        memset(dp, 0, sizeof(dp));
        int n, sum = 0;
        double maxp;
        cin >> maxp >> n;
        for (int i = 1; i <= n; i++) {
            cin >> w[i] >> p[i];
            sum += w[i];
        }
        dp[0] = 1;
        for (int i = 1; i <= n; i++)
            for (int j = sum; j >= w[i]; j--)
                dp[j] = max(dp[j], dp[j - w[i]] * (1 - p[i]));
        int ans = 0;
        for (int j = 0; j <= sum; j++)
            if ((1 - dp[j]) - maxp < 1e-6)
                ans = max(ans, j);
        cout << ans << endl;
    }
}

猜你喜欢

转载自blog.csdn.net/qq_42764823/article/details/88614677
今日推荐